#include <stdio.h>
#include <string.h>
#include <math.h>
#include <conio.h>
#include <stdarg.h>
#include <errno.h>

#include "asmlib.h"

int main(int argc, char * argv[]);

int main(int argc, char * argv[]) {

  TOperacao *cOP;
  TOperando *cOp1, *cOp2;
  TOperacao Op;

  FILE *srcfile, *outfile;

  char Mnemonic[7], Op1[20], Op2[20];
  char linha [80];  
 
  if  (argc < 2) {
	  printf("Use: assembler sourcefile outputfile\n");
      return BAD_ARGS;
  };
  
  srcfile = fopen(argv[1], "rb");
  if  (srcfile == NULL) {
  	  perror(NULL);
      printf("ERR: srcfile not found!\n");  	
      return BAD_SRC_FILE;
  };	
  outfile = fopen(argv[2], "w");
  if  (outfile == NULL) {
  	  perror(NULL);
      printf("ERR: arquivo de destino no pode ser acessado!\n");  	
      return BAD_TARGET_FILE;
  };	  

  while(fgets(linha, 80, srcfile), strupr(linha), !(feof(srcfile) || !strcmp(linha, "END"))) {
        printf("\nlinha = \"%s\"\n", linha);
	    SplitInstruction(linha, Mnemonic, Op1, Op2);       
	    cOp1 = EncodeOperando(Op1);	   
	    cOp2 = EncodeOperando(Op2);	   
	    
	    Op = GetOperation(Mnemonic, cOp1, cOp2);
	    Op.Op1 = *cOp1;
		Op.Op2 = *cOp2;
	    
	    EncodeOperacao(&Op);
	    ExibeOperacao(&Op);	    
	    printf("\n");
	    
	    fwrite(&Op.format.Opcode, 1, 1, outfile);
	    if (Op.format.size > 1) 
		   fwrite(&Op.format.data_modrm, 1, 1, outfile);	       
		if (Op.format.size > 2) 
	       fwrite(&Op.format.data2, 1, 1, outfile);	       
		if (Op.format.size > 3) 
	       fwrite(&Op.format.data3, 1, 1, outfile);	
		if (Op.format.size > 4)
           fwrite(&Op.format.data4, 1, 1, outfile);	       
  };
  fclose(outfile);
  fclose(srcfile);
}
